PBMParameter (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.cmp

## Class PBMParameter

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.cmp.PBMParameter

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class PBMParameter
      extends ASN1Object

  PBMParameter ::= SEQUENCE { salt OCTET STRING, -- note: implementations MAY wish to limit acceptable sizes -- of this string to values appropriate for their environment -- in order to reduce the risk of denial-of-service attacks owf AlgorithmIdentifier, -- AlgId for a One-Way Function (SHA-1 recommended) iterationCount INTEGER, -- number of times the OWF is applied -- note: implementations MAY wish to limit acceptable sizes -- of this integer to values appropriate for their environment -- in order to reduce the risk of denial-of-service attacks mac AlgorithmIdentifier -- the MAC AlgId (e.g., DES-MAC, Triple-DES-MAC [PKCS11], } -- or HMAC [RFC2104, RFC2202])

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PBMParameter(ASN1OctetString salt, AlgorithmIdentifier owf, ASN1Integer iterationCount, AlgorithmIdentifier mac)`
    `PBMParameter(byte[] salt, AlgorithmIdentifier owf, int iterationCount, AlgorithmIdentifier mac)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static PBMParameter` | `getInstance(java.lang.Object o)`
    `ASN1Integer` | `getIterationCount()`
    `AlgorithmIdentifier` | `getMac()`
    `AlgorithmIdentifier` | `getOwf()`
    `ASN1OctetString` | `getSalt()`
    `ASN1Primitive` | `toASN1Primitive()` PBMParameter ::= SEQUENCE { salt OCTET STRING, -- note: implementations MAY wish to limit acceptable sizes -- of this string to values appropriate for their environment -- in order to reduce the risk of denial-of-service attacks owf AlgorithmIdentifier, -- AlgId for a One-Way Function (SHA-1 recommended) iterationCount INTEGER, -- number of times the OWF is applied -- note: implementations MAY wish to limit acceptable sizes -- of this integer to values appropriate for their environment -- in order to reduce the risk of denial-of-service attacks mac AlgorithmIdentifier -- the MAC AlgId (e.g., DES-MAC, Triple-DES-MAC [PKCS11], } -- or HMAC [RFC2104, RFC2202])

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PBMParameter

          public PBMParameter(byte[] salt,
                              AlgorithmIdentifier owf,
                              int iterationCount,
                              AlgorithmIdentifier mac)

    - #### PBMParameter

          public PBMParameter(ASN1OctetString salt,
                              AlgorithmIdentifier owf,
                              ASN1Integer iterationCount,
                              AlgorithmIdentifier mac)

  - ### Method Detail

    - #### getInstance

          public static PBMParameter getInstance(java.lang.Object o)

    - #### getSalt

          public ASN1OctetString getSalt()

    - #### getOwf

          public AlgorithmIdentifier getOwf()

    - #### getIterationCount

          public ASN1Integer getIterationCount()

    - #### getMac

          public AlgorithmIdentifier getMac()

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

            PBMParameter ::= SEQUENCE {
                                  salt                OCTET STRING,
                                  -- note:  implementations MAY wish to limit acceptable sizes
                                  -- of this string to values appropriate for their environment
                                  -- in order to reduce the risk of denial-of-service attacks
                                  owf                 AlgorithmIdentifier,
                                  -- AlgId for a One-Way Function (SHA-1 recommended)
                                  iterationCount      INTEGER,
                                  -- number of times the OWF is applied
                                  -- note:  implementations MAY wish to limit acceptable sizes
                                  -- of this integer to values appropriate for their environment
                                  -- in order to reduce the risk of denial-of-service attacks
                                  mac                 AlgorithmIdentifier
                                  -- the MAC AlgId (e.g., DES-MAC, Triple-DES-MAC [PKCS11],
              }   -- or HMAC [RFC2104, RFC2202])

      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        a basic ASN.1 object representation.